<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBlackoutDate ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBlackoutDate
 * @subpackage Arrays
 */
class ArrayOfBlackoutDate extends AbstractStructArrayBase
{
    /**
     * The BlackoutDate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BlackoutDate[]
     */
    public $BlackoutDate;
    /**
     * Constructor method for ArrayOfBlackoutDate
     * @uses ArrayOfBlackoutDate::setBlackoutDate()
     * @param \StructType\BlackoutDate[] $blackoutDate
     */
    public function __construct(array $blackoutDate = array())
    {
        $this
            ->setBlackoutDate($blackoutDate);
    }
    /**
     * Get BlackoutDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BlackoutDate[]|null
     */
    public function getBlackoutDate()
    {
        return isset($this->BlackoutDate) ? $this->BlackoutDate : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBlackoutDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBlackoutDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBlackoutDateForArrayConstraintsFromSetBlackoutDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBlackoutDateBlackoutDateItem) {
            // validation for constraint: itemType
            if (!$arrayOfBlackoutDateBlackoutDateItem instanceof \StructType\BlackoutDate) {
                $invalidValues[] = is_object($arrayOfBlackoutDateBlackoutDateItem) ? get_class($arrayOfBlackoutDateBlackoutDateItem) : sprintf('%s(%s)', gettype($arrayOfBlackoutDateBlackoutDateItem), var_export($arrayOfBlackoutDateBlackoutDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BlackoutDate property can only contain items of type \StructType\BlackoutDate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BlackoutDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BlackoutDate[] $blackoutDate
     * @return \ArrayType\ArrayOfBlackoutDate
     */
    public function setBlackoutDate(array $blackoutDate = array())
    {
        // validation for constraint: array
        if ('' !== ($blackoutDateArrayErrorMessage = self::validateBlackoutDateForArrayConstraintsFromSetBlackoutDate($blackoutDate))) {
            throw new \InvalidArgumentException($blackoutDateArrayErrorMessage, __LINE__);
        }
        if (is_null($blackoutDate) || (is_array($blackoutDate) && empty($blackoutDate))) {
            unset($this->BlackoutDate);
        } else {
            $this->BlackoutDate = $blackoutDate;
        }
        return $this;
    }
    /**
     * Add item to BlackoutDate value
     * @throws \InvalidArgumentException
     * @param \StructType\BlackoutDate $item
     * @return \ArrayType\ArrayOfBlackoutDate
     */
    public function addToBlackoutDate(\StructType\BlackoutDate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BlackoutDate) {
            throw new \InvalidArgumentException(sprintf('The BlackoutDate property can only contain items of type \StructType\BlackoutDate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BlackoutDate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BlackoutDate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BlackoutDate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BlackoutDate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BlackoutDate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BlackoutDate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BlackoutDate
     */
    public function getAttributeName()
    {
        return 'BlackoutDate';
    }
}
