<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMarketFlightNumber ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMarketFlightNumber
 * @subpackage Arrays
 */
class ArrayOfMarketFlightNumber extends AbstractStructArrayBase
{
    /**
     * The MarketFlightNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MarketFlightNumber[]
     */
    public $MarketFlightNumber;
    /**
     * Constructor method for ArrayOfMarketFlightNumber
     * @uses ArrayOfMarketFlightNumber::setMarketFlightNumber()
     * @param \StructType\MarketFlightNumber[] $marketFlightNumber
     */
    public function __construct(array $marketFlightNumber = array())
    {
        $this
            ->setMarketFlightNumber($marketFlightNumber);
    }
    /**
     * Get MarketFlightNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MarketFlightNumber[]|null
     */
    public function getMarketFlightNumber()
    {
        return isset($this->MarketFlightNumber) ? $this->MarketFlightNumber : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMarketFlightNumber method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMarketFlightNumber method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMarketFlightNumberForArrayConstraintsFromSetMarketFlightNumber(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMarketFlightNumberMarketFlightNumberItem) {
            // validation for constraint: itemType
            if (!$arrayOfMarketFlightNumberMarketFlightNumberItem instanceof \StructType\MarketFlightNumber) {
                $invalidValues[] = is_object($arrayOfMarketFlightNumberMarketFlightNumberItem) ? get_class($arrayOfMarketFlightNumberMarketFlightNumberItem) : sprintf('%s(%s)', gettype($arrayOfMarketFlightNumberMarketFlightNumberItem), var_export($arrayOfMarketFlightNumberMarketFlightNumberItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MarketFlightNumber property can only contain items of type \StructType\MarketFlightNumber, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MarketFlightNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MarketFlightNumber[] $marketFlightNumber
     * @return \ArrayType\ArrayOfMarketFlightNumber
     */
    public function setMarketFlightNumber(array $marketFlightNumber = array())
    {
        // validation for constraint: array
        if ('' !== ($marketFlightNumberArrayErrorMessage = self::validateMarketFlightNumberForArrayConstraintsFromSetMarketFlightNumber($marketFlightNumber))) {
            throw new \InvalidArgumentException($marketFlightNumberArrayErrorMessage, __LINE__);
        }
        if (is_null($marketFlightNumber) || (is_array($marketFlightNumber) && empty($marketFlightNumber))) {
            unset($this->MarketFlightNumber);
        } else {
            $this->MarketFlightNumber = $marketFlightNumber;
        }
        return $this;
    }
    /**
     * Add item to MarketFlightNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\MarketFlightNumber $item
     * @return \ArrayType\ArrayOfMarketFlightNumber
     */
    public function addToMarketFlightNumber(\StructType\MarketFlightNumber $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MarketFlightNumber) {
            throw new \InvalidArgumentException(sprintf('The MarketFlightNumber property can only contain items of type \StructType\MarketFlightNumber, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MarketFlightNumber[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MarketFlightNumber|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MarketFlightNumber|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MarketFlightNumber|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MarketFlightNumber|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MarketFlightNumber|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MarketFlightNumber
     */
    public function getAttributeName()
    {
        return 'MarketFlightNumber';
    }
}
