<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRestrictedTime ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRestrictedTime
 * @subpackage Arrays
 */
class ArrayOfRestrictedTime extends AbstractStructArrayBase
{
    /**
     * The RestrictedTime
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RestrictedTime[]
     */
    public $RestrictedTime;
    /**
     * Constructor method for ArrayOfRestrictedTime
     * @uses ArrayOfRestrictedTime::setRestrictedTime()
     * @param \StructType\RestrictedTime[] $restrictedTime
     */
    public function __construct(array $restrictedTime = array())
    {
        $this
            ->setRestrictedTime($restrictedTime);
    }
    /**
     * Get RestrictedTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RestrictedTime[]|null
     */
    public function getRestrictedTime()
    {
        return isset($this->RestrictedTime) ? $this->RestrictedTime : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRestrictedTime method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRestrictedTime method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRestrictedTimeForArrayConstraintsFromSetRestrictedTime(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRestrictedTimeRestrictedTimeItem) {
            // validation for constraint: itemType
            if (!$arrayOfRestrictedTimeRestrictedTimeItem instanceof \StructType\RestrictedTime) {
                $invalidValues[] = is_object($arrayOfRestrictedTimeRestrictedTimeItem) ? get_class($arrayOfRestrictedTimeRestrictedTimeItem) : sprintf('%s(%s)', gettype($arrayOfRestrictedTimeRestrictedTimeItem), var_export($arrayOfRestrictedTimeRestrictedTimeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RestrictedTime property can only contain items of type \StructType\RestrictedTime, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RestrictedTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RestrictedTime[] $restrictedTime
     * @return \ArrayType\ArrayOfRestrictedTime
     */
    public function setRestrictedTime(array $restrictedTime = array())
    {
        // validation for constraint: array
        if ('' !== ($restrictedTimeArrayErrorMessage = self::validateRestrictedTimeForArrayConstraintsFromSetRestrictedTime($restrictedTime))) {
            throw new \InvalidArgumentException($restrictedTimeArrayErrorMessage, __LINE__);
        }
        if (is_null($restrictedTime) || (is_array($restrictedTime) && empty($restrictedTime))) {
            unset($this->RestrictedTime);
        } else {
            $this->RestrictedTime = $restrictedTime;
        }
        return $this;
    }
    /**
     * Add item to RestrictedTime value
     * @throws \InvalidArgumentException
     * @param \StructType\RestrictedTime $item
     * @return \ArrayType\ArrayOfRestrictedTime
     */
    public function addToRestrictedTime(\StructType\RestrictedTime $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RestrictedTime) {
            throw new \InvalidArgumentException(sprintf('The RestrictedTime property can only contain items of type \StructType\RestrictedTime, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RestrictedTime[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RestrictedTime|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RestrictedTime|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RestrictedTime|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RestrictedTime|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RestrictedTime|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RestrictedTime
     */
    public function getAttributeName()
    {
        return 'RestrictedTime';
    }
}
