<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTravelDate ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTravelDate
 * @subpackage Arrays
 */
class ArrayOfTravelDate extends AbstractStructArrayBase
{
    /**
     * The TravelDate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TravelDate[]
     */
    public $TravelDate;
    /**
     * Constructor method for ArrayOfTravelDate
     * @uses ArrayOfTravelDate::setTravelDate()
     * @param \StructType\TravelDate[] $travelDate
     */
    public function __construct(array $travelDate = array())
    {
        $this
            ->setTravelDate($travelDate);
    }
    /**
     * Get TravelDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TravelDate[]|null
     */
    public function getTravelDate()
    {
        return isset($this->TravelDate) ? $this->TravelDate : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTravelDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTravelDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTravelDateForArrayConstraintsFromSetTravelDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTravelDateTravelDateItem) {
            // validation for constraint: itemType
            if (!$arrayOfTravelDateTravelDateItem instanceof \StructType\TravelDate) {
                $invalidValues[] = is_object($arrayOfTravelDateTravelDateItem) ? get_class($arrayOfTravelDateTravelDateItem) : sprintf('%s(%s)', gettype($arrayOfTravelDateTravelDateItem), var_export($arrayOfTravelDateTravelDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TravelDate property can only contain items of type \StructType\TravelDate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TravelDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TravelDate[] $travelDate
     * @return \ArrayType\ArrayOfTravelDate
     */
    public function setTravelDate(array $travelDate = array())
    {
        // validation for constraint: array
        if ('' !== ($travelDateArrayErrorMessage = self::validateTravelDateForArrayConstraintsFromSetTravelDate($travelDate))) {
            throw new \InvalidArgumentException($travelDateArrayErrorMessage, __LINE__);
        }
        if (is_null($travelDate) || (is_array($travelDate) && empty($travelDate))) {
            unset($this->TravelDate);
        } else {
            $this->TravelDate = $travelDate;
        }
        return $this;
    }
    /**
     * Add item to TravelDate value
     * @throws \InvalidArgumentException
     * @param \StructType\TravelDate $item
     * @return \ArrayType\ArrayOfTravelDate
     */
    public function addToTravelDate(\StructType\TravelDate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TravelDate) {
            throw new \InvalidArgumentException(sprintf('The TravelDate property can only contain items of type \StructType\TravelDate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TravelDate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TravelDate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TravelDate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TravelDate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TravelDate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TravelDate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TravelDate
     */
    public function getAttributeName()
    {
        return 'TravelDate';
    }
}
