<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVoucherAdvancedDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVoucherAdvancedDetails
 * @subpackage Arrays
 */
class ArrayOfVoucherAdvancedDetails extends AbstractStructArrayBase
{
    /**
     * The VoucherAdvancedDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VoucherAdvancedDetails[]
     */
    public $VoucherAdvancedDetails;
    /**
     * Constructor method for ArrayOfVoucherAdvancedDetails
     * @uses ArrayOfVoucherAdvancedDetails::setVoucherAdvancedDetails()
     * @param \StructType\VoucherAdvancedDetails[] $voucherAdvancedDetails
     */
    public function __construct(array $voucherAdvancedDetails = array())
    {
        $this
            ->setVoucherAdvancedDetails($voucherAdvancedDetails);
    }
    /**
     * Get VoucherAdvancedDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VoucherAdvancedDetails[]|null
     */
    public function getVoucherAdvancedDetails()
    {
        return isset($this->VoucherAdvancedDetails) ? $this->VoucherAdvancedDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVoucherAdvancedDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVoucherAdvancedDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVoucherAdvancedDetailsForArrayConstraintsFromSetVoucherAdvancedDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVoucherAdvancedDetailsVoucherAdvancedDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfVoucherAdvancedDetailsVoucherAdvancedDetailsItem instanceof \StructType\VoucherAdvancedDetails) {
                $invalidValues[] = is_object($arrayOfVoucherAdvancedDetailsVoucherAdvancedDetailsItem) ? get_class($arrayOfVoucherAdvancedDetailsVoucherAdvancedDetailsItem) : sprintf('%s(%s)', gettype($arrayOfVoucherAdvancedDetailsVoucherAdvancedDetailsItem), var_export($arrayOfVoucherAdvancedDetailsVoucherAdvancedDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VoucherAdvancedDetails property can only contain items of type \StructType\VoucherAdvancedDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VoucherAdvancedDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VoucherAdvancedDetails[] $voucherAdvancedDetails
     * @return \ArrayType\ArrayOfVoucherAdvancedDetails
     */
    public function setVoucherAdvancedDetails(array $voucherAdvancedDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($voucherAdvancedDetailsArrayErrorMessage = self::validateVoucherAdvancedDetailsForArrayConstraintsFromSetVoucherAdvancedDetails($voucherAdvancedDetails))) {
            throw new \InvalidArgumentException($voucherAdvancedDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($voucherAdvancedDetails) || (is_array($voucherAdvancedDetails) && empty($voucherAdvancedDetails))) {
            unset($this->VoucherAdvancedDetails);
        } else {
            $this->VoucherAdvancedDetails = $voucherAdvancedDetails;
        }
        return $this;
    }
    /**
     * Add item to VoucherAdvancedDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\VoucherAdvancedDetails $item
     * @return \ArrayType\ArrayOfVoucherAdvancedDetails
     */
    public function addToVoucherAdvancedDetails(\StructType\VoucherAdvancedDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VoucherAdvancedDetails) {
            throw new \InvalidArgumentException(sprintf('The VoucherAdvancedDetails property can only contain items of type \StructType\VoucherAdvancedDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VoucherAdvancedDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VoucherAdvancedDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VoucherAdvancedDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VoucherAdvancedDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VoucherAdvancedDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VoucherAdvancedDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VoucherAdvancedDetails
     */
    public function getAttributeName()
    {
        return 'VoucherAdvancedDetails';
    }
}
