<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RetrieveVoucher' => '\\StructType\\RetrieveVoucher',
            'RetrieveVoucherResponse' => '\\StructType\\RetrieveVoucherResponse',
            'RetrieveAdvancedVoucherDetails' => '\\StructType\\RetrieveAdvancedVoucherDetails',
            'RetrieveAdvancedVoucherDetailsResponse' => '\\StructType\\RetrieveAdvancedVoucherDetailsResponse',
            'ArrayOfVoucher' => '\\ArrayType\\ArrayOfVoucher',
            'Voucher' => '\\StructType\\Voucher',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'ViewVoucher' => '\\StructType\\ViewVoucher',
            'ViewVoucherAdvancedDetails' => '\\StructType\\ViewVoucherAdvancedDetails',
            'ArrayOfVoucherAdvancedDetails' => '\\ArrayType\\ArrayOfVoucherAdvancedDetails',
            'VoucherAdvancedDetails' => '\\StructType\\VoucherAdvancedDetails',
            'ArrayOfHistory' => '\\ArrayType\\ArrayOfHistory',
            'History' => '\\StructType\\History',
            'VoucherPerson' => '\\StructType\\VoucherPerson',
            'ArrayOfPersonContactInfo' => '\\ArrayType\\ArrayOfPersonContactInfo',
            'PersonContactInfo' => '\\StructType\\PersonContactInfo',
            'VoucherReasonRules' => '\\StructType\\VoucherReasonRules',
            'BlackoutDateRule' => '\\StructType\\BlackoutDateRule',
            'VoucherRuleBase' => '\\StructType\\VoucherRuleBase',
            'ArrayOfBlackoutDate' => '\\ArrayType\\ArrayOfBlackoutDate',
            'BlackoutDate' => '\\StructType\\BlackoutDate',
            'DaysOfWeekRule' => '\\StructType\\DaysOfWeekRule',
            'EffectiveDaysRule' => '\\StructType\\EffectiveDaysRule',
            'FareBasisRule' => '\\StructType\\FareBasisRule',
            'FareClassRule' => '\\StructType\\FareClassRule',
            'IncludesAutoRule' => '\\StructType\\IncludesAutoRule',
            'IncludesFareRule' => '\\StructType\\IncludesFareRule',
            'IncludesHotelRule' => '\\StructType\\IncludesHotelRule',
            'IncludesPenaltiesRule' => '\\StructType\\IncludesPenaltiesRule',
            'IncludesSsrRule' => '\\StructType\\IncludesSsrRule',
            'IncludesTaxesRule' => '\\StructType\\IncludesTaxesRule',
            'MarketFlightNumberRule' => '\\StructType\\MarketFlightNumberRule',
            'ArrayOfMarketFlightNumber' => '\\ArrayType\\ArrayOfMarketFlightNumber',
            'MarketFlightNumber' => '\\StructType\\MarketFlightNumber',
            'MarketOriginDestinationRule' => '\\StructType\\MarketOriginDestinationRule',
            'ArrayOfMarketOriginDestination' => '\\ArrayType\\ArrayOfMarketOriginDestination',
            'MarketOriginDestination' => '\\StructType\\MarketOriginDestination',
            'MarketRule' => '\\StructType\\MarketRule',
            'ResChannelRule' => '\\StructType\\ResChannelRule',
            'RestrictedTimeRule' => '\\StructType\\RestrictedTimeRule',
            'ArrayOfRestrictedTime' => '\\ArrayType\\ArrayOfRestrictedTime',
            'RestrictedTime' => '\\StructType\\RestrictedTime',
            'SingleUseRule' => '\\StructType\\SingleUseRule',
            'TransferableRule' => '\\StructType\\TransferableRule',
            'TravelDateRule' => '\\StructType\\TravelDateRule',
            'ArrayOfTravelDate' => '\\ArrayType\\ArrayOfTravelDate',
            'TravelDate' => '\\StructType\\TravelDate',
            'TripTypeRule' => '\\StructType\\TripTypeRule',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'Payment' => '\\StructType\\Payment',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'ArrayOfDayOfWeek' => '\\ArrayType\\ArrayOfDayOfWeek',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
        );
    }
}
