<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IncludesPenaltiesRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:IncludesPenaltiesRule
 * @subpackage Structs
 */
class IncludesPenaltiesRule extends VoucherRuleBase
{
    /**
     * The IncludesPenalties
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IncludesPenalties;
    /**
     * Constructor method for IncludesPenaltiesRule
     * @uses IncludesPenaltiesRule::setIncludesPenalties()
     * @param bool $includesPenalties
     */
    public function __construct($includesPenalties = null)
    {
        $this
            ->setIncludesPenalties($includesPenalties);
    }
    /**
     * Get IncludesPenalties value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIncludesPenalties()
    {
        return isset($this->IncludesPenalties) ? $this->IncludesPenalties : null;
    }
    /**
     * Set IncludesPenalties value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $includesPenalties
     * @return \StructType\IncludesPenaltiesRule
     */
    public function setIncludesPenalties($includesPenalties = null)
    {
        // validation for constraint: boolean
        if (!is_null($includesPenalties) && !is_bool($includesPenalties)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includesPenalties, true), gettype($includesPenalties)), __LINE__);
        }
        if (is_null($includesPenalties) || (is_array($includesPenalties) && empty($includesPenalties))) {
            unset($this->IncludesPenalties);
        } else {
            $this->IncludesPenalties = $includesPenalties;
        }
        return $this;
    }
}
