<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IncludesSsrRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:IncludesSsrRule
 * @subpackage Structs
 */
class IncludesSsrRule extends VoucherRuleBase
{
    /**
     * The IncludesSsr
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IncludesSsr;
    /**
     * Constructor method for IncludesSsrRule
     * @uses IncludesSsrRule::setIncludesSsr()
     * @param bool $includesSsr
     */
    public function __construct($includesSsr = null)
    {
        $this
            ->setIncludesSsr($includesSsr);
    }
    /**
     * Get IncludesSsr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIncludesSsr()
    {
        return isset($this->IncludesSsr) ? $this->IncludesSsr : null;
    }
    /**
     * Set IncludesSsr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $includesSsr
     * @return \StructType\IncludesSsrRule
     */
    public function setIncludesSsr($includesSsr = null)
    {
        // validation for constraint: boolean
        if (!is_null($includesSsr) && !is_bool($includesSsr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includesSsr, true), gettype($includesSsr)), __LINE__);
        }
        if (is_null($includesSsr) || (is_array($includesSsr) && empty($includesSsr))) {
            unset($this->IncludesSsr);
        } else {
            $this->IncludesSsr = $includesSsr;
        }
        return $this;
    }
}
