<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IncludesTaxesRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:IncludesTaxesRule
 * @subpackage Structs
 */
class IncludesTaxesRule extends VoucherRuleBase
{
    /**
     * The IncludesTaxes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IncludesTaxes;
    /**
     * Constructor method for IncludesTaxesRule
     * @uses IncludesTaxesRule::setIncludesTaxes()
     * @param bool $includesTaxes
     */
    public function __construct($includesTaxes = null)
    {
        $this
            ->setIncludesTaxes($includesTaxes);
    }
    /**
     * Get IncludesTaxes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIncludesTaxes()
    {
        return isset($this->IncludesTaxes) ? $this->IncludesTaxes : null;
    }
    /**
     * Set IncludesTaxes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $includesTaxes
     * @return \StructType\IncludesTaxesRule
     */
    public function setIncludesTaxes($includesTaxes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includesTaxes) && !is_bool($includesTaxes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includesTaxes, true), gettype($includesTaxes)), __LINE__);
        }
        if (is_null($includesTaxes) || (is_array($includesTaxes) && empty($includesTaxes))) {
            unset($this->IncludesTaxes);
        } else {
            $this->IncludesTaxes = $includesTaxes;
        }
        return $this;
    }
}
