<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MarketRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:MarketRule
 * @subpackage Structs
 */
class MarketRule extends VoucherRuleBase
{
    /**
     * The Markets
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $Markets;
    /**
     * Constructor method for MarketRule
     * @uses MarketRule::setMarkets()
     * @param \ArrayType\ArrayOfstring $markets
     */
    public function __construct(\ArrayType\ArrayOfstring $markets = null)
    {
        $this
            ->setMarkets($markets);
    }
    /**
     * Get Markets value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getMarkets()
    {
        return isset($this->Markets) ? $this->Markets : null;
    }
    /**
     * Set Markets value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $markets
     * @return \StructType\MarketRule
     */
    public function setMarkets(\ArrayType\ArrayOfstring $markets = null)
    {
        if (is_null($markets) || (is_array($markets) && empty($markets))) {
            unset($this->Markets);
        } else {
            $this->Markets = $markets;
        }
        return $this;
    }
}
