<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PersonContactInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PersonContactInfo
 * @subpackage Structs
 */
class PersonContactInfo extends AbstractStructBase
{
    /**
     * The AreaCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AreaCode;
    /**
     * The ContactField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContactField;
    /**
     * The ContactId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $ContactId;
    /**
     * The ContactType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContactType;
    /**
     * The CountryCallingCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CountryCallingCode;
    /**
     * The Display
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Display;
    /**
     * The Extension
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Extension;
    /**
     * The PersonOrgId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $PersonOrgId;
    /**
     * The PhoneNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PhoneNumber;
    /**
     * The PreferenceOrder
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PreferenceOrder;
    /**
     * The PreferredContactMethod
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $PreferredContactMethod;
    /**
     * Constructor method for PersonContactInfo
     * @uses PersonContactInfo::setAreaCode()
     * @uses PersonContactInfo::setContactField()
     * @uses PersonContactInfo::setContactId()
     * @uses PersonContactInfo::setContactType()
     * @uses PersonContactInfo::setCountryCallingCode()
     * @uses PersonContactInfo::setDisplay()
     * @uses PersonContactInfo::setExtension()
     * @uses PersonContactInfo::setPersonOrgId()
     * @uses PersonContactInfo::setPhoneNumber()
     * @uses PersonContactInfo::setPreferenceOrder()
     * @uses PersonContactInfo::setPreferredContactMethod()
     * @param string $areaCode
     * @param string $contactField
     * @param int $contactId
     * @param string $contactType
     * @param string $countryCallingCode
     * @param string $display
     * @param string $extension
     * @param int $personOrgId
     * @param string $phoneNumber
     * @param int $preferenceOrder
     * @param bool $preferredContactMethod
     */
    public function __construct($areaCode = null, $contactField = null, $contactId = null, $contactType = null, $countryCallingCode = null, $display = null, $extension = null, $personOrgId = null, $phoneNumber = null, $preferenceOrder = null, $preferredContactMethod = null)
    {
        $this
            ->setAreaCode($areaCode)
            ->setContactField($contactField)
            ->setContactId($contactId)
            ->setContactType($contactType)
            ->setCountryCallingCode($countryCallingCode)
            ->setDisplay($display)
            ->setExtension($extension)
            ->setPersonOrgId($personOrgId)
            ->setPhoneNumber($phoneNumber)
            ->setPreferenceOrder($preferenceOrder)
            ->setPreferredContactMethod($preferredContactMethod);
    }
    /**
     * Get AreaCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAreaCode()
    {
        return isset($this->AreaCode) ? $this->AreaCode : null;
    }
    /**
     * Set AreaCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $areaCode
     * @return \StructType\PersonContactInfo
     */
    public function setAreaCode($areaCode = null)
    {
        // validation for constraint: string
        if (!is_null($areaCode) && !is_string($areaCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($areaCode, true), gettype($areaCode)), __LINE__);
        }
        if (is_null($areaCode) || (is_array($areaCode) && empty($areaCode))) {
            unset($this->AreaCode);
        } else {
            $this->AreaCode = $areaCode;
        }
        return $this;
    }
    /**
     * Get ContactField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContactField()
    {
        return isset($this->ContactField) ? $this->ContactField : null;
    }
    /**
     * Set ContactField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contactField
     * @return \StructType\PersonContactInfo
     */
    public function setContactField($contactField = null)
    {
        // validation for constraint: string
        if (!is_null($contactField) && !is_string($contactField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactField, true), gettype($contactField)), __LINE__);
        }
        if (is_null($contactField) || (is_array($contactField) && empty($contactField))) {
            unset($this->ContactField);
        } else {
            $this->ContactField = $contactField;
        }
        return $this;
    }
    /**
     * Get ContactId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getContactId()
    {
        return isset($this->ContactId) ? $this->ContactId : null;
    }
    /**
     * Set ContactId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $contactId
     * @return \StructType\PersonContactInfo
     */
    public function setContactId($contactId = null)
    {
        // validation for constraint: int
        if (!is_null($contactId) && !(is_int($contactId) || ctype_digit($contactId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($contactId, true), gettype($contactId)), __LINE__);
        }
        if (is_null($contactId) || (is_array($contactId) && empty($contactId))) {
            unset($this->ContactId);
        } else {
            $this->ContactId = $contactId;
        }
        return $this;
    }
    /**
     * Get ContactType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContactType()
    {
        return isset($this->ContactType) ? $this->ContactType : null;
    }
    /**
     * Set ContactType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contactType
     * @return \StructType\PersonContactInfo
     */
    public function setContactType($contactType = null)
    {
        // validation for constraint: string
        if (!is_null($contactType) && !is_string($contactType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactType, true), gettype($contactType)), __LINE__);
        }
        if (is_null($contactType) || (is_array($contactType) && empty($contactType))) {
            unset($this->ContactType);
        } else {
            $this->ContactType = $contactType;
        }
        return $this;
    }
    /**
     * Get CountryCallingCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCountryCallingCode()
    {
        return isset($this->CountryCallingCode) ? $this->CountryCallingCode : null;
    }
    /**
     * Set CountryCallingCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $countryCallingCode
     * @return \StructType\PersonContactInfo
     */
    public function setCountryCallingCode($countryCallingCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCallingCode) && !is_string($countryCallingCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryCallingCode, true), gettype($countryCallingCode)), __LINE__);
        }
        if (is_null($countryCallingCode) || (is_array($countryCallingCode) && empty($countryCallingCode))) {
            unset($this->CountryCallingCode);
        } else {
            $this->CountryCallingCode = $countryCallingCode;
        }
        return $this;
    }
    /**
     * Get Display value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDisplay()
    {
        return isset($this->Display) ? $this->Display : null;
    }
    /**
     * Set Display value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $display
     * @return \StructType\PersonContactInfo
     */
    public function setDisplay($display = null)
    {
        // validation for constraint: string
        if (!is_null($display) && !is_string($display)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($display, true), gettype($display)), __LINE__);
        }
        if (is_null($display) || (is_array($display) && empty($display))) {
            unset($this->Display);
        } else {
            $this->Display = $display;
        }
        return $this;
    }
    /**
     * Get Extension value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExtension()
    {
        return isset($this->Extension) ? $this->Extension : null;
    }
    /**
     * Set Extension value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $extension
     * @return \StructType\PersonContactInfo
     */
    public function setExtension($extension = null)
    {
        // validation for constraint: string
        if (!is_null($extension) && !is_string($extension)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($extension, true), gettype($extension)), __LINE__);
        }
        if (is_null($extension) || (is_array($extension) && empty($extension))) {
            unset($this->Extension);
        } else {
            $this->Extension = $extension;
        }
        return $this;
    }
    /**
     * Get PersonOrgId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getPersonOrgId()
    {
        return isset($this->PersonOrgId) ? $this->PersonOrgId : null;
    }
    /**
     * Set PersonOrgId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $personOrgId
     * @return \StructType\PersonContactInfo
     */
    public function setPersonOrgId($personOrgId = null)
    {
        // validation for constraint: int
        if (!is_null($personOrgId) && !(is_int($personOrgId) || ctype_digit($personOrgId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($personOrgId, true), gettype($personOrgId)), __LINE__);
        }
        if (is_null($personOrgId) || (is_array($personOrgId) && empty($personOrgId))) {
            unset($this->PersonOrgId);
        } else {
            $this->PersonOrgId = $personOrgId;
        }
        return $this;
    }
    /**
     * Get PhoneNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPhoneNumber()
    {
        return isset($this->PhoneNumber) ? $this->PhoneNumber : null;
    }
    /**
     * Set PhoneNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $phoneNumber
     * @return \StructType\PersonContactInfo
     */
    public function setPhoneNumber($phoneNumber = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber) && !is_string($phoneNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phoneNumber, true), gettype($phoneNumber)), __LINE__);
        }
        if (is_null($phoneNumber) || (is_array($phoneNumber) && empty($phoneNumber))) {
            unset($this->PhoneNumber);
        } else {
            $this->PhoneNumber = $phoneNumber;
        }
        return $this;
    }
    /**
     * Get PreferenceOrder value
     * @return int|null
     */
    public function getPreferenceOrder()
    {
        return $this->PreferenceOrder;
    }
    /**
     * Set PreferenceOrder value
     * @param int $preferenceOrder
     * @return \StructType\PersonContactInfo
     */
    public function setPreferenceOrder($preferenceOrder = null)
    {
        // validation for constraint: int
        if (!is_null($preferenceOrder) && !(is_int($preferenceOrder) || ctype_digit($preferenceOrder))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($preferenceOrder, true), gettype($preferenceOrder)), __LINE__);
        }
        $this->PreferenceOrder = $preferenceOrder;
        return $this;
    }
    /**
     * Get PreferredContactMethod value
     * @return bool|null
     */
    public function getPreferredContactMethod()
    {
        return $this->PreferredContactMethod;
    }
    /**
     * Set PreferredContactMethod value
     * @param bool $preferredContactMethod
     * @return \StructType\PersonContactInfo
     */
    public function setPreferredContactMethod($preferredContactMethod = null)
    {
        // validation for constraint: boolean
        if (!is_null($preferredContactMethod) && !is_bool($preferredContactMethod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($preferredContactMethod, true), gettype($preferredContactMethod)), __LINE__);
        }
        $this->PreferredContactMethod = $preferredContactMethod;
        return $this;
    }
}
