<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RetrieveVoucher StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RetrieveVoucher
 * @subpackage Structs
 */
class RetrieveVoucher extends TransactionInfo
{
    /**
     * The RetrieveVoucherRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetrieveVoucher
     */
    public $RetrieveVoucherRequest;
    /**
     * The Vouchers
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfVoucher
     */
    public $Vouchers;
    /**
     * Constructor method for RetrieveVoucher
     * @uses RetrieveVoucher::setRetrieveVoucherRequest()
     * @uses RetrieveVoucher::setVouchers()
     * @param \StructType\RetrieveVoucher $retrieveVoucherRequest
     * @param \ArrayType\ArrayOfVoucher $vouchers
     */
    public function __construct(\StructType\RetrieveVoucher $retrieveVoucherRequest = null, \ArrayType\ArrayOfVoucher $vouchers = null)
    {
        $this
            ->setRetrieveVoucherRequest($retrieveVoucherRequest)
            ->setVouchers($vouchers);
    }
    /**
     * Get RetrieveVoucherRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetrieveVoucher|null
     */
    public function getRetrieveVoucherRequest()
    {
        return isset($this->RetrieveVoucherRequest) ? $this->RetrieveVoucherRequest : null;
    }
    /**
     * Set RetrieveVoucherRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\RetrieveVoucher $retrieveVoucherRequest
     * @return \StructType\RetrieveVoucher
     */
    public function setRetrieveVoucherRequest(\StructType\RetrieveVoucher $retrieveVoucherRequest = null)
    {
        if (is_null($retrieveVoucherRequest) || (is_array($retrieveVoucherRequest) && empty($retrieveVoucherRequest))) {
            unset($this->RetrieveVoucherRequest);
        } else {
            $this->RetrieveVoucherRequest = $retrieveVoucherRequest;
        }
        return $this;
    }
    /**
     * Get Vouchers value
     * @return \ArrayType\ArrayOfVoucher|null
     */
    public function getVouchers()
    {
        return $this->Vouchers;
    }
    /**
     * Set Vouchers value
     * @param \ArrayType\ArrayOfVoucher $vouchers
     * @return \StructType\RetrieveVoucher
     */
    public function setVouchers(\ArrayType\ArrayOfVoucher $vouchers = null)
    {
        $this->Vouchers = $vouchers;
        return $this;
    }
}
