<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SingleUseRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SingleUseRule
 * @subpackage Structs
 */
class SingleUseRule extends VoucherRuleBase
{
    /**
     * The SingleUse
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $SingleUse;
    /**
     * Constructor method for SingleUseRule
     * @uses SingleUseRule::setSingleUse()
     * @param bool $singleUse
     */
    public function __construct($singleUse = null)
    {
        $this
            ->setSingleUse($singleUse);
    }
    /**
     * Get SingleUse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getSingleUse()
    {
        return isset($this->SingleUse) ? $this->SingleUse : null;
    }
    /**
     * Set SingleUse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $singleUse
     * @return \StructType\SingleUseRule
     */
    public function setSingleUse($singleUse = null)
    {
        // validation for constraint: boolean
        if (!is_null($singleUse) && !is_bool($singleUse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($singleUse, true), gettype($singleUse)), __LINE__);
        }
        if (is_null($singleUse) || (is_array($singleUse) && empty($singleUse))) {
            unset($this->SingleUse);
        } else {
            $this->SingleUse = $singleUse;
        }
        return $this;
    }
}
