<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransferableRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TransferableRule
 * @subpackage Structs
 */
class TransferableRule extends VoucherRuleBase
{
    /**
     * The Transferable
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Transferable;
    /**
     * Constructor method for TransferableRule
     * @uses TransferableRule::setTransferable()
     * @param string $transferable
     */
    public function __construct($transferable = null)
    {
        $this
            ->setTransferable($transferable);
    }
    /**
     * Get Transferable value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTransferable()
    {
        return isset($this->Transferable) ? $this->Transferable : null;
    }
    /**
     * Set Transferable value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $transferable
     * @return \StructType\TransferableRule
     */
    public function setTransferable($transferable = null)
    {
        // validation for constraint: string
        if (!is_null($transferable) && !is_string($transferable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transferable, true), gettype($transferable)), __LINE__);
        }
        if (is_null($transferable) || (is_array($transferable) && empty($transferable))) {
            unset($this->Transferable);
        } else {
            $this->Transferable = $transferable;
        }
        return $this;
    }
}
