<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TripTypeRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TripTypeRule
 * @subpackage Structs
 */
class TripTypeRule extends VoucherRuleBase
{
    /**
     * The TripType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TripType;
    /**
     * Constructor method for TripTypeRule
     * @uses TripTypeRule::setTripType()
     * @param string $tripType
     */
    public function __construct($tripType = null)
    {
        $this
            ->setTripType($tripType);
    }
    /**
     * Get TripType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTripType()
    {
        return isset($this->TripType) ? $this->TripType : null;
    }
    /**
     * Set TripType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tripType
     * @return \StructType\TripTypeRule
     */
    public function setTripType($tripType = null)
    {
        // validation for constraint: string
        if (!is_null($tripType) && !is_string($tripType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tripType, true), gettype($tripType)), __LINE__);
        }
        if (is_null($tripType) || (is_array($tripType) && empty($tripType))) {
            unset($this->TripType);
        } else {
            $this->TripType = $tripType;
        }
        return $this;
    }
}
